#ifndef PPSSUMM_BASEINTEGER
#define PPSSUMM_BASEINTEGER

#include <string>
#include <cstdlib>
#include <iostream>

template <typename T>
class BaseInteger 
{
    public:
    BaseInteger() : _base_integer(0) { }
    BaseInteger(const T& s ) : _base_integer(s) { }

    // Accessor
    T get() const { return _base_integer; }
    T set( const T& s ) 
    { 
        T tmp = _base_integer;
        _base_integer = s;
        return tmp; 
    }

    // Operators
    bool operator<(const BaseInteger& s) const
    { 
        return _base_integer < s._base_integer;
    }
    bool operator>(const BaseInteger& s) const
    { 
        return _base_integer > s._base_integer;
    }
    bool operator==(const BaseInteger& s) const
    { 
        return _base_integer == s._base_integer;
    }

    // prefix and postfix 
    BaseInteger operator=(const T& s)
    { 
        _base_integer = s;
        return *this;
    }

    //
    BaseInteger operator++()
    { 
        ++_base_integer;
        return *this;
    }
    BaseInteger operator++(int i)
    { 
        ++_base_integer;
        return *this;
    }

    BaseInteger operator--()
    { 
        --_base_integer;
        return *this;
    }
    BaseInteger operator--(int i)
    { 
        --_base_integer;
        return *this;
    }

    BaseInteger operator+=(const T& i)
    { 
        _base_integer+=i;
        return *this;
    }
    BaseInteger operator-=(const T& i)
    { 
        _base_integer-=i;
        return *this;
    }

    friend std::ostream &operator<<(std::ostream& os , const BaseInteger& s)
    {
        T tmp = s.get();
        if (!tmp)
        {
        os << "&nbsp;";
        }
        else
        {
        os << tmp;
        }
       return os;
    }
    private:
    T _base_integer;
};
#endif
