#ifndef PPSSUMM_FITSTABLE
#define PPSSUMM_FITSTABLE

#include <string>
#include <map>
#include "Dal.h"
#include "Tracer.h"
#include "errstr.h"


template< typename Ii_ , typename Oi_ >
void getAttribute( Table* tbl, Ii_ first_ , Ii_ last_ ,  Oi_ return_ ,  bool fatalnotfound = 1) 
{
/* Find the attribute keywords in the input contaier, add it to the output container */

    while ( first_ != last_ ) {

        if ( tbl->hasAttribute(*first_) ) {
            
            *return_++ = tbl->attribute(*first_);

        } else if ( fatalnotfound ) {
            
            errstr << "Unable to find attribute" <<*first_ 
                << Sas::fatal("ppssumm:ATTRIBUTENOTFOUND")
            ;

        }
        first_++;

    }
}
/*
template<>
void getAttribute< typename map<std::string , Attribute* >::iterator 
    ,  typename map<std::string , Attribute*>::iterator >
( Table* tbl , map<std::string , Attribute*>::iterator first_ , map<std::string , Attribute*>::iterator last_ ,  bool fatalnotfound = 1) 
{

    while ( first_ != last_ ) {

        if ( tbl->hasAttribute(first_->first) ) {
            
            first_->second = tbl->attribute(first_->first);

        } else if ( fatalnotfound ) {

            errstr << "Unable to find attribute" << first_->first
                << Sas::fatal("ppssumm:ATTRIBUTENOTFOUND")
            ;

        }
        first_++;

    }
}
*/

#endif

