#include "key_algo.h"

/*
 * These functions are used to make keys 
 * Those without filenames tend to get used in map<> and <a name="">
 * Those with filenames tend to be used in <a href="">
 */

namespace ppssumm_internal
{


std::string makekey( const Instrument& i , const Exp_id& e , const Src_num& s )
{
    	std::stringstream ss;
	ss << "i" << i << "e" << e << "s" << s ;
	return ss.str();
}

std::string makekey( const Instrument& i , const Exp_id& e , const Osw_id& q , const Src_num& s  )
{
    	std::stringstream ss;
	ss << "i" << i << "e" << e << "q" << q << "s" << s ;
	return ss.str();
}

std::string makekey( const Instrument& i , const Exp_id& e , const Osw_id& q )
{
    	std::stringstream ss;
	ss << "i" << i << "e" << e << "q" << q ;
	return ss.str();
}

std::string makekey( const Instrument& i , const Exp_id& e )
{
    	std::stringstream ss;
	ss << "i" << i << "e" << e ;
	return ss.str();
}

std::string makekey( const Filename& f 
    , const Instrument& i 
    , const Exp_id& e 
    , const Src_num& s 
){
    	std::stringstream ss;
	ss << f.asString() << "#" << makekey( i , e , s ) ;
	return ss.str();
}

std::string makekey( const Filename& f 
    , const Instrument& i 
    , const Exp_id& e 
    , const Osw_id& q 
    , const Src_num& s
){
    	std::stringstream ss;
	ss << f.asString() << "#" << makekey( i , e , q , s ) ;
	return ss.str();
}

std::string makekey( const Filename& f 
    , const Instrument& i 
    , const Exp_id& e 
    , const Osw_id& q 
){
    	std::stringstream ss;
	ss << f.asString() << "#" << makekey( i , e , q ) ;
	return ss.str();
}

std::string makekey( const Filename& f 
    , const Instrument& i 
    , const Exp_id& e 
){
    	std::stringstream ss;
	ss << f.asString() << "#" << makekey( i , e ) ;
	return ss.str();
}

}
