#include "string_algo.h"

namespace ppssumm_internal
{

    std::string stripdir( const std::string& s )
    {
        std::string::size_type cut = s.rfind('/');

        return ( cut == std::string::npos) 
            ? s
            : s.substr( cut+1 , std::string::npos)
        ;
    }

    std::string truncTime( const std::string& s ) 
    {
        /* Given a string in dateTtime.nnn format strip off the .nnn */
        return s.substr( 0 , s.rfind(".") );
    }


    char toUpper(const char c)
    {
        return static_cast<char>( toupper( static_cast<int>(c) ) );
    }

    char toLower(const char c)
    {
        return static_cast<char>( tolower( static_cast<int>(c) ) );
    }

    // Return stripdir(stringParameter( s )) 
    std::string pagename(const std::string& s)
    {
	return stripdir(stringParameter( s ));
    }
};
